apeman-service-entity
==========

<!---
This file is generated by ape-tmpl. Do not update manually.
--->

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]
[![JS Standard][bd_standard_shield_url]][bd_standard_url]

[bd_repo_url]: https://github.com/apeman-service-labo/apeman-service-entity
[bd_travis_url]: http://travis-ci.org/apeman-service-labo/apeman-service-entity
[bd_travis_shield_url]: http://img.shields.io/travis/apeman-service-labo/apeman-service-entity.svg?style=flat
[bd_travis_com_url]: http://travis-ci.com/apeman-service-labo/apeman-service-entity
[bd_travis_com_shield_url]: https://api.travis-ci.com/apeman-service-labo/apeman-service-entity.svg?token=
[bd_license_url]: https://github.com/apeman-service-labo/apeman-service-entity/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/apeman-service-labo/apeman-service-entity
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/apeman-service-labo/apeman-service-entity.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/apeman-service-labo/apeman-service-entity.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/apeman-service-labo/apeman-service-entity
[bd_gemnasium_shield_url]: https://gemnasium.com/apeman-service-labo/apeman-service-entity.svg
[bd_npm_url]: http://www.npmjs.org/package/apeman-service-entity
[bd_npm_shield_url]: http://img.shields.io/npm/v/apeman-service-entity.svg?style=flat
[bd_standard_url]: http://standardjs.com/
[bd_standard_shield_url]: https://img.shields.io/badge/code%20style-standard-brightgreen.svg

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

Apemna service for entity

<!-- Description End -->


<!-- Overview Start -->
<a name="overview"></a>



<!-- Overview End -->


<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/guides/01.Installation.md.hbs" Start -->

<a name="section-doc-guides-01-installation-md"></a>

Installation
-----

```bash
$ npm install apeman-service-entity --save
```


<!-- Section from "doc/guides/01.Installation.md.hbs" End -->

<!-- Section from "doc/guides/02.Usage.md.hbs" Start -->

<a name="section-doc-guides-02-usage-md"></a>

Usage
---------

```javascript
#!/usr/bin/env node

'use strict'

const { ApEntityService } = require('apeman-service-entity')
const { createStore } = require('redux')
const { reducer } = require('apeman-service-base')
const co = require('co')

co(function * () {
  let store = createStore(reducer)
  let service = new ApEntityService(store)


}).catch((err) => console.error(err))
```


<!-- Section from "doc/guides/02.Usage.md.hbs" End -->

<!-- Section from "doc/guides/03.API.md.hbs" Start -->

<a name="section-doc-guides-03-a-p-i-md"></a>

API
---------

# apeman-service-entity@2.2.1

Apemna service for entity

+ Functions
  + [create(args)](#apeman-service-entity-function-create)
+ [ApEntityService](apeman-service-entity-classes) Class
  + [new ApEntityService(store, options)](#apeman-service-entity-classes-ap-entity-service-constructor)
  + [service.getEntityList(entityName)](#apeman-service-entity-classes-ap-entity-service-getEntityList)
  + [service.getEntityOne(entityName)](#apeman-service-entity-classes-ap-entity-service-getEntityOne)
  + [service.getEntityResources(entityName)](#apeman-service-entity-classes-ap-entity-service-getEntityResources)
  + [service.updateEntityResources(entityName, entities)](#apeman-service-entity-classes-ap-entity-service-updateEntityResources)
  + [service.setEntityList(entityName, entities, counts)](#apeman-service-entity-classes-ap-entity-service-setEntityList)
  + [service.pushEntityList(entityName, entities, counts)](#apeman-service-entity-classes-ap-entity-service-pushEntityList)
  + [service.unshiftEntityList(entityName, entities, counts)](#apeman-service-entity-classes-ap-entity-service-unshiftEntityList)
  + [service.setEntityOne(entityName, entity)](#apeman-service-entity-classes-ap-entity-service-setEntityOne)
  + [service.clearEntityList(entityName)](#apeman-service-entity-classes-ap-entity-service-clearEntityList)
  + [service.clearEntityOne(entityName)](#apeman-service-entity-classes-ap-entity-service-clearEntityOne)
  + [service.clearEntityResource(entityName)](#apeman-service-entity-classes-ap-entity-service-clearEntityResource)
  + [service.purgeEntity(entityName)](#apeman-service-entity-classes-ap-entity-service-purgeEntity)
  + [service.invalidateEntityCache(entityName)](#apeman-service-entity-classes-ap-entity-service-invalidateEntityCache)

## Functions

<a class='md-heading-link' name="apeman-service-entity-function-create" ></a>

### create(args) -> `ApEntityService`

Create the service instance

| Param | Type | Description |
| ----- | --- | -------- |
| args | * |  |



<a class='md-heading-link' name="apeman-service-entity-classes"></a>

## ApEntityService Class

Service


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-constructor" ></a>

### new ApEntityService(store, options)

Constructor of ApEntityService class

| Param | Type | Description |
| ----- | --- | -------- |
| store | Object | Redux store |
| options | Object | Optional settings |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-getEntityList" ></a>

### service.getEntityList(entityName) -> `Object`

Get entity as list

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-getEntityOne" ></a>

### service.getEntityOne(entityName) -> `*`

Get detailed entity

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-getEntityResources" ></a>

### service.getEntityResources(entityName) -> `Object`

Get entity resources.

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-updateEntityResources" ></a>

### service.updateEntityResources(entityName, entities) -> `Promise`

Update entity resources.

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |
| entities | Array.&lt;Object&gt;,Object | Entities to push |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-setEntityList" ></a>

### service.setEntityList(entityName, entities, counts) -> `Promise`

Set entity list.

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |
| entities | Array.&lt;Object&gt; | Entities to push |
| counts | Object | Count info |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-pushEntityList" ></a>

### service.pushEntityList(entityName, entities, counts) -> `Promise`

Push to entity list.

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |
| entities | Array.&lt;Object&gt; | Entities to push |
| counts | Object | Count info |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-unshiftEntityList" ></a>

### service.unshiftEntityList(entityName, entities, counts) -> `Promise`

Unshift to entity list.

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |
| entities | Array.&lt;Object&gt; | Entities to unshift |
| counts | Object | Count info |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-setEntityOne" ></a>

### service.setEntityOne(entityName, entity) -> `Promise`

Set entity one

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |
| entity | Object | Entity to set. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-clearEntityList" ></a>

### service.clearEntityList(entityName) -> `Promise`

Clear entity list

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-clearEntityOne" ></a>

### service.clearEntityOne(entityName) -> `Promise`

Clear entity one

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-clearEntityResource" ></a>

### service.clearEntityResource(entityName) -> `Promise`

Clear entity resource

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-purgeEntity" ></a>

### service.purgeEntity(entityName) -> `Promise`

Clear entity one

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-invalidateEntityCache" ></a>

### service.invalidateEntityCache(entityName) -> `Promise`

Invalidate entity cache

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |







<!-- Section from "doc/guides/03.API.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/apeman-service-labo/apeman-service-entity/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [apeman][apeman_url]

[apeman_url]: https://github.com/apeman-labo/apeman

<!-- Links End -->
