# apeman-service-entity@3.0.0

Apemna service for entity

+ Functions
  + [create(args)](#apeman-service-entity-function-create)
+ [ApEntityService](apeman-service-entity-classes) Class
  + [new ApEntityService(store, options)](#apeman-service-entity-classes-ap-entity-service-constructor)
  + [service.getEntityList(entityName)](#apeman-service-entity-classes-ap-entity-service-getEntityList)
  + [service.getEntityOne(entityName)](#apeman-service-entity-classes-ap-entity-service-getEntityOne)
  + [service.getEntityResources(entityName)](#apeman-service-entity-classes-ap-entity-service-getEntityResources)
  + [service.updateEntityResources(entityName, entities)](#apeman-service-entity-classes-ap-entity-service-updateEntityResources)
  + [service.setEntityList(entityName, entities, counts)](#apeman-service-entity-classes-ap-entity-service-setEntityList)
  + [service.pushEntityList(entityName, entities, counts)](#apeman-service-entity-classes-ap-entity-service-pushEntityList)
  + [service.unshiftEntityList(entityName, entities, counts)](#apeman-service-entity-classes-ap-entity-service-unshiftEntityList)
  + [service.setEntityOne(entityName, entity)](#apeman-service-entity-classes-ap-entity-service-setEntityOne)
  + [service.clearEntityList(entityName)](#apeman-service-entity-classes-ap-entity-service-clearEntityList)
  + [service.clearEntityOne(entityName)](#apeman-service-entity-classes-ap-entity-service-clearEntityOne)
  + [service.clearEntityResource(entityName)](#apeman-service-entity-classes-ap-entity-service-clearEntityResource)
  + [service.purgeEntity(entityName)](#apeman-service-entity-classes-ap-entity-service-purgeEntity)
  + [service.invalidateEntityCache(entityName)](#apeman-service-entity-classes-ap-entity-service-invalidateEntityCache)

## Functions

<a class='md-heading-link' name="apeman-service-entity-function-create" ></a>

### create(args) -> `ApEntityService`

Create the service instance

| Param | Type | Description |
| ----- | --- | -------- |
| args | * |  |



<a class='md-heading-link' name="apeman-service-entity-classes"></a>

## ApEntityService Class

Service


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-constructor" ></a>

### new ApEntityService(store, options)

Constructor of ApEntityService class

| Param | Type | Description |
| ----- | --- | -------- |
| store | Object | Redux store |
| options | Object | Optional settings |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-getEntityList" ></a>

### service.getEntityList(entityName) -> `Object`

Get entity as list

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-getEntityOne" ></a>

### service.getEntityOne(entityName) -> `*`

Get detailed entity

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-getEntityResources" ></a>

### service.getEntityResources(entityName) -> `Object`

Get entity resources.

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-updateEntityResources" ></a>

### service.updateEntityResources(entityName, entities) -> `Promise`

Update entity resources.

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |
| entities | Array.&lt;Object&gt;,Object | Entities to push |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-setEntityList" ></a>

### service.setEntityList(entityName, entities, counts) -> `Promise`

Set entity list.

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |
| entities | Array.&lt;Object&gt; | Entities to push |
| counts | Object | Count info |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-pushEntityList" ></a>

### service.pushEntityList(entityName, entities, counts) -> `Promise`

Push to entity list.

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |
| entities | Array.&lt;Object&gt; | Entities to push |
| counts | Object | Count info |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-unshiftEntityList" ></a>

### service.unshiftEntityList(entityName, entities, counts) -> `Promise`

Unshift to entity list.

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |
| entities | Array.&lt;Object&gt; | Entities to unshift |
| counts | Object | Count info |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-setEntityOne" ></a>

### service.setEntityOne(entityName, entity) -> `Promise`

Set entity one

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |
| entity | Object | Entity to set. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-clearEntityList" ></a>

### service.clearEntityList(entityName) -> `Promise`

Clear entity list

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-clearEntityOne" ></a>

### service.clearEntityOne(entityName) -> `Promise`

Clear entity one

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-clearEntityResource" ></a>

### service.clearEntityResource(entityName) -> `Promise`

Clear entity resource

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-purgeEntity" ></a>

### service.purgeEntity(entityName) -> `Promise`

Clear entity one

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |


<a class='md-heading-link' name="apeman-service-entity-classes-ap-entity-service-invalidateEntityCache" ></a>

### service.invalidateEntityCache(entityName) -> `Promise`

Invalidate entity cache

| Param | Type | Description |
| ----- | --- | -------- |
| entityName | string | Name of entity. |




