/**
 * Test case for apEntityService.
 * Runs with mocha.
 */
'use strict'

const ApEntityService = require('../lib/ap_entity_service.js')
const apemanstore = require('apemanstore')
const assert = require('assert')
const co = require('co')

describe('ap-entity-service', function () {
  this.timeout(3000)

  before(() => co(function * () {

  }))

  after(() => co(function * () {

  }))

  it('Do service', () => co(function * () {
    let store = apemanstore().sub('entities/hoge')
    let service = new ApEntityService(store)
    assert.ok(service)

    let {
      getEntityList, pushEntityList,
      getEntityOne, setEntityOne,
      setEntityList, unshiftEntityList
    } = service

    yield pushEntityList('foo', [ { id: 1, name: 'foo' }, { id: 2, name: 'foo2' } ])
    assert.deepEqual(getEntityList('foo').entities, [ { id: 1, name: 'foo' }, { id: 2, name: 'foo2' } ])

    yield setEntityOne('foo', { id: 1, name: 'One Foo' })
    assert.deepEqual(getEntityOne('foo'), { id: 1, name: 'One Foo' })

    yield setEntityList('hoge', [ { id: 1, name: 'hoge01' } ], { total: 100 })
    assert.deepEqual(getEntityList('hoge').counts, { total: 100 })

    yield unshiftEntityList('hoge', [ { id: 5, name: 'hoge05' } ], { total: 120 })

    assert.ok(getEntityList('hoge').more)
  }))
})

/* global describe, before, after, it */
